Index: uspace/lib/posix/include/posix/signal.h
===================================================================
--- uspace/lib/posix/include/posix/signal.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/signal.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,4 +36,8 @@
 #define POSIX_SIGNAL_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "sys/types.h"
 #include <posix/ucontext.h>
@@ -59,6 +63,6 @@
 	int si_errno;
 
-	pid_t si_pid;
-	uid_t si_uid;
+	__POSIX_DEF__(pid_t) si_pid;
+	__POSIX_DEF__(uid_t) si_uid;
 	void *si_addr;
 	int si_status;
@@ -66,16 +70,16 @@
 	long si_band;
 
-	union sigval si_value;
-} siginfo_t;
-
-struct sigaction {
+	union __POSIX_DEF__(sigval) si_value;
+} __POSIX_DEF__(siginfo_t);
+
+struct __POSIX_DEF__(sigaction) {
 	void (*sa_handler)(int);
-	sigset_t sa_mask;
+	__POSIX_DEF__(sigset_t) sa_mask;
 	int sa_flags;
-	void (*sa_sigaction)(int, siginfo_t *, void *);
+	void (*sa_sigaction)(int, __POSIX_DEF__(siginfo_t) *, void *);
 };
 
 
-/* Values of sigevent::sigev_notify */
+/* Values of __POSIX_DEF__(sigevent)::sigev_notify */
 #undef SIGEV_NONE
 #undef SIGEV_SIGNAL
@@ -225,25 +229,25 @@
 };
 
-extern int sigaction(int sig, const struct sigaction *__restrict__ act,
-    struct sigaction *__restrict__ oact);
-
-extern void (*signal(int sig, void (*func)(int)))(int);
-extern int raise(int sig);
-extern int kill(pid_t pid, int sig);
-extern int killpg(pid_t pid, int sig);
-
-extern void psiginfo(const siginfo_t *pinfo, const char *message);
-extern void psignal(int signum, const char *message);
-
-extern int sigemptyset(sigset_t *set);
-extern int sigfillset(sigset_t *set);
-extern int sigaddset(sigset_t *set, int signo);
-extern int sigdelset(sigset_t *set, int signo);
-extern int sigismember(const sigset_t *set, int signo);
-
-extern int thread_sigmask(int how, const sigset_t *__restrict__ set,
-    sigset_t *__restrict__ oset);
-extern int sigprocmask(int how, const sigset_t *__restrict__ set,
-    sigset_t *__restrict__ oset);
+extern int __POSIX_DEF__(sigaction)(int sig, const struct __POSIX_DEF__(sigaction) *__restrict__ act,
+    struct __POSIX_DEF__(sigaction) *__restrict__ oact);
+
+extern void (*__POSIX_DEF__(signal)(int sig, void (*func)(int)))(int);
+extern int __POSIX_DEF__(raise)(int sig);
+extern int __POSIX_DEF__(kill)(__POSIX_DEF__(pid_t) pid, int sig);
+extern int __POSIX_DEF__(killpg)(__POSIX_DEF__(pid_t) pid, int sig);
+
+extern void __POSIX_DEF__(psiginfo)(const __POSIX_DEF__(siginfo_t) *pinfo, const char *message);
+extern void __POSIX_DEF__(psignal)(int signum, const char *message);
+
+extern int __POSIX_DEF__(sigemptyset)(__POSIX_DEF__(sigset_t) *set);
+extern int __POSIX_DEF__(sigfillset)(__POSIX_DEF__(sigset_t) *set);
+extern int __POSIX_DEF__(sigaddset)(__POSIX_DEF__(sigset_t) *set, int signo);
+extern int __POSIX_DEF__(sigdelset)(__POSIX_DEF__(sigset_t) *set, int signo);
+extern int __POSIX_DEF__(sigismember)(const __POSIX_DEF__(sigset_t) *set, int signo);
+
+extern int __POSIX_DEF__(thread_sigmask)(int how, const __POSIX_DEF__(sigset_t) *__restrict__ set,
+    __POSIX_DEF__(sigset_t) *__restrict__ oset);
+extern int __POSIX_DEF__(sigprocmask)(int how, const __POSIX_DEF__(sigset_t) *__restrict__ set,
+    __POSIX_DEF__(sigset_t) *__restrict__ oset);
 
 
Index: uspace/lib/posix/include/posix/stddef.h
===================================================================
--- uspace/lib/posix/include/posix/stddef.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/stddef.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,4 +36,8 @@
 #define POSIX_STDDEF_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "sys/types.h"
 
Index: uspace/lib/posix/include/posix/stdint.h
===================================================================
--- uspace/lib/posix/include/posix/stdint.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/stdint.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,4 +36,8 @@
 #define POSIX_STDINT_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "libc/stdint.h"
 
Index: uspace/lib/posix/include/posix/stdio.h
===================================================================
--- uspace/lib/posix/include/posix/stdio.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/stdio.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,5 +37,12 @@
 #define POSIX_STDIO_H_
 
-#include "libc/stdio.h"
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+/* DEBUG macro does not belong to POSIX stdio.h. Its unconditional
+ * definition in the native stdio.h causes unexpected behaviour of
+ * applications which uses their own DEBUG macro (e.g. debugging
+ * output is printed even if not desirable). */
+#undef DEBUG
+#endif
 
 #include "stddef.h"
@@ -65,4 +72,15 @@
 typedef struct _IO_FILE FILE;
 
+#ifndef LIBPOSIX_INTERNAL
+	enum _buffer_type {
+		/** No buffering */
+		_IONBF,
+		/** Line buffering */
+		_IOLBF,
+		/** Full buffering */
+		_IOFBF
+	};
+#endif
+
 extern FILE *stdin;
 extern FILE *stdout;
@@ -81,14 +99,14 @@
 extern int puts(const char *);
 
-extern int fprintf(FILE *, const char*, ...) _HELENOS_PRINTF_ATTRIBUTE(2, 3);
+extern int fprintf(FILE *, const char*, ...) PRINTF_ATTRIBUTE(2, 3);
 extern int vfprintf(FILE *, const char *, va_list);
 
-extern int printf(const char *, ...) _HELENOS_PRINTF_ATTRIBUTE(1, 2);
+extern int printf(const char *, ...) PRINTF_ATTRIBUTE(1, 2);
 extern int vprintf(const char *, va_list);
 
-extern int snprintf(char *, size_t , const char *, ...) _HELENOS_PRINTF_ATTRIBUTE(3, 4);
+extern int snprintf(char *, size_t , const char *, ...) PRINTF_ATTRIBUTE(3, 4);
 #ifdef _GNU_SOURCE
 extern int vasprintf(char **, const char *, va_list);
-extern int asprintf(char **, const char *, ...) _HELENOS_PRINTF_ATTRIBUTE(2, 3);
+extern int asprintf(char **, const char *, ...) PRINTF_ATTRIBUTE(2, 3);
 #endif
 extern int vsnprintf(char *, size_t, const char *, va_list);
@@ -117,84 +135,84 @@
 #undef L_ctermid
 #define L_ctermid PATH_MAX
-extern char *ctermid(char *s);
+extern char *__POSIX_DEF__(ctermid)(char *s);
 
 /* Error Recovery */
-extern void clearerr(FILE *stream);
+extern void __POSIX_DEF__(clearerr)(FILE *stream);
 
 /* Input/Output */
 #undef putc
 #define putc fputc
-extern int fputs(const char *__restrict__ s, FILE *__restrict__ stream);
+extern int __POSIX_DEF__(fputs)(const char *__restrict__ s, FILE *__restrict__ stream);
 #undef getc
 #define getc fgetc
-extern int ungetc(int c, FILE *stream);
-extern ssize_t getdelim(char **__restrict__ lineptr, size_t *__restrict__ n,
+extern int __POSIX_DEF__(ungetc)(int c, FILE *stream);
+extern ssize_t __POSIX_DEF__(getdelim)(char **__restrict__ lineptr, size_t *__restrict__ n,
     int delimiter, FILE *__restrict__ stream);
-extern ssize_t getline(char **__restrict__ lineptr, size_t *__restrict__ n,
+extern ssize_t __POSIX_DEF__(getline)(char **__restrict__ lineptr, size_t *__restrict__ n,
     FILE *__restrict__ stream);
 
 /* Opening Streams */
-extern FILE *freopen(const char *__restrict__ filename,
+extern FILE *__POSIX_DEF__(freopen)(const char *__restrict__ filename,
     const char *__restrict__ mode, FILE *__restrict__ stream);
 
 /* Error Messages */
-extern void perror(const char *s);
+extern void __POSIX_DEF__(perror)(const char *s);
 
 /* File Positioning */
 typedef struct {
 	off64_t offset;
-} fpos_t;
-
-extern int fsetpos(FILE *stream, const fpos_t *pos);
-extern int fgetpos(FILE *__restrict__ stream, fpos_t *__restrict__ pos);
-extern int fseek(FILE *stream, long offset, int whence);
-extern int fseeko(FILE *stream, off_t offset, int whence);
-extern long ftell(FILE *stream);
-extern off_t ftello(FILE *stream);
+} __POSIX_DEF__(fpos_t);
+
+extern int __POSIX_DEF__(fsetpos)(FILE *stream, const __POSIX_DEF__(fpos_t) *pos);
+extern int __POSIX_DEF__(fgetpos)(FILE *__restrict__ stream, __POSIX_DEF__(fpos_t) *__restrict__ pos);
+extern int __POSIX_DEF__(fseek)(FILE *stream, long offset, int whence);
+extern int __POSIX_DEF__(fseeko)(FILE *stream, __POSIX_DEF__(off_t) offset, int whence);
+extern long __POSIX_DEF__(ftell)(FILE *stream);
+extern __POSIX_DEF__(off_t) __POSIX_DEF__(ftello)(FILE *stream);
 
 /* Flushing Buffers */
-extern int fflush(FILE *stream);
+extern int __POSIX_DEF__(fflush)(FILE *stream);
 
 /* Formatted Output */
-extern int dprintf(int fildes, const char *__restrict__ format, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(2, 3);
-extern int vdprintf(int fildes, const char *__restrict__ format, va_list ap);
-extern int sprintf(char *__restrict__ s, const char *__restrict__ format, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(2, 3);
-extern int vsprintf(char *__restrict__ s, const char *__restrict__ format, va_list ap);
+extern int __POSIX_DEF__(dprintf)(int fildes, const char *__restrict__ format, ...)
+    PRINTF_ATTRIBUTE(2, 3);
+extern int __POSIX_DEF__(vdprintf)(int fildes, const char *__restrict__ format, va_list ap);
+extern int __POSIX_DEF__(sprintf)(char *__restrict__ s, const char *__restrict__ format, ...)
+    PRINTF_ATTRIBUTE(2, 3);
+extern int __POSIX_DEF__(vsprintf)(char *__restrict__ s, const char *__restrict__ format, va_list ap);
 
 /* Formatted Input */
-extern int fscanf(
+extern int __POSIX_DEF__(fscanf)(
     FILE *__restrict__ stream, const char *__restrict__ format, ...);
-extern int vfscanf(
+extern int __POSIX_DEF__(vfscanf)(
     FILE *__restrict__ stream, const char *__restrict__ format, va_list arg);
-extern int scanf(const char *__restrict__ format, ...);
-extern int vscanf(const char *__restrict__ format, va_list arg);
-extern int sscanf(
+extern int __POSIX_DEF__(scanf)(const char *__restrict__ format, ...);
+extern int __POSIX_DEF__(vscanf)(const char *__restrict__ format, va_list arg);
+extern int __POSIX_DEF__(sscanf)(
     const char *__restrict__ s, const char *__restrict__ format, ...);
-extern int vsscanf(
+extern int __POSIX_DEF__(vsscanf)(
     const char *__restrict__ s, const char *__restrict__ format, va_list arg);
 
 /* File Locking */
-extern void flockfile(FILE *file);
-extern int ftrylockfile(FILE *file);
-extern void funlockfile(FILE *file);
-extern int getc_unlocked(FILE *stream);
-extern int getchar_unlocked(void);
-extern int putc_unlocked(int c, FILE *stream);
-extern int putchar_unlocked(int c);
+extern void __POSIX_DEF__(flockfile)(FILE *file);
+extern int __POSIX_DEF__(ftrylockfile)(FILE *file);
+extern void __POSIX_DEF__(funlockfile)(FILE *file);
+extern int __POSIX_DEF__(getc_unlocked)(FILE *stream);
+extern int __POSIX_DEF__(getchar_unlocked)(void);
+extern int __POSIX_DEF__(putc_unlocked)(int c, FILE *stream);
+extern int __POSIX_DEF__(putchar_unlocked)(int c);
 
 /* Deleting Files */
-extern int remove(const char *path);
+extern int __POSIX_DEF__(remove)(const char *path);
 
 /* Renaming Files */
-extern int rename(const char *oldname, const char *newname);
+extern int __POSIX_DEF__(rename)(const char *oldname, const char *newname);
 
 /* Temporary Files */
 #undef L_tmpnam
 #define L_tmpnam PATH_MAX
-extern char *tmpnam(char *s);
-extern char *tempnam(const char *dir, const char *pfx);
-extern FILE *tmpfile(void);
+extern char *__POSIX_DEF__(tmpnam)(char *s);
+extern char *__POSIX_DEF__(tempnam)(const char *dir, const char *pfx);
+extern FILE *__POSIX_DEF__(tmpfile)(void);
 
 
Index: uspace/lib/posix/include/posix/stdlib.h
===================================================================
--- uspace/lib/posix/include/posix/stdlib.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/stdlib.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,4 +37,8 @@
 #define POSIX_STDLIB_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "sys/types.h"
 
@@ -49,12 +53,12 @@
 #define EXIT_SUCCESS 0
 #define _Exit exit
-extern int atexit(void (*func)(void));
+extern int __POSIX_DEF__(atexit)(void (*func)(void));
 extern void exit(int status) __attribute__((noreturn));
 extern void abort(void) __attribute__((noreturn));
 
 /* Absolute Value */
-extern int abs(int i);
-extern long labs(long i);
-extern long long llabs(long long i);
+extern int __POSIX_DEF__(abs)(int i);
+extern long __POSIX_DEF__(labs)(long i);
+extern long long __POSIX_DEF__(llabs)(long long i);
 
 /* Integer Division */
@@ -62,69 +66,69 @@
 typedef struct {
 	int quot, rem;
-} div_t;
+} __POSIX_DEF__(div_t);
 
 typedef struct {
 	long quot, rem;
-} ldiv_t;
+} __POSIX_DEF__(ldiv_t);
 
 typedef struct {
 	long long quot, rem;
-} lldiv_t;
+} __POSIX_DEF__(lldiv_t);
 
-extern div_t div(int numer, int denom);
-extern ldiv_t ldiv(long numer, long denom);
-extern lldiv_t lldiv(long long numer, long long denom);
+extern __POSIX_DEF__(div_t) __POSIX_DEF__(div)(int numer, int denom);
+extern __POSIX_DEF__(ldiv_t) __POSIX_DEF__(ldiv)(long numer, long denom);
+extern __POSIX_DEF__(lldiv_t) __POSIX_DEF__(lldiv)(long long numer, long long denom);
 
 /* Array Functions */
-extern void qsort(void *array, size_t count, size_t size,
+extern void __POSIX_DEF__(qsort)(void *array, size_t count, size_t size,
     int (*compare)(const void *, const void *));
-extern void *bsearch(const void *key, const void *base,
+extern void *__POSIX_DEF__(bsearch)(const void *key, const void *base,
     size_t nmemb, size_t size, int (*compar)(const void *, const void *));
 
 /* Environment Access */
-extern char *getenv(const char *name);
-extern int putenv(char *string);
-extern int system(const char *string);
+extern char *__POSIX_DEF__(getenv)(const char *name);
+extern int __POSIX_DEF__(putenv)(char *string);
+extern int __POSIX_DEF__(system)(const char *string);
 
 /* Symbolic Links */
-extern char *realpath(const char *__restrict__ name, char *__restrict__ resolved);
+extern char *__POSIX_DEF__(realpath)(const char *__restrict__ name, char *__restrict__ resolved);
 
 /* Floating Point Conversion */
-extern double atof(const char *nptr);
-extern float strtof(const char *__restrict__ nptr, char **__restrict__ endptr);
-extern double strtod(const char *__restrict__ nptr, char **__restrict__ endptr);
-extern long double strtold(const char *__restrict__ nptr, char **__restrict__ endptr);
+extern double __POSIX_DEF__(atof)(const char *nptr);
+extern float __POSIX_DEF__(strtof)(const char *__restrict__ nptr, char **__restrict__ endptr);
+extern double __POSIX_DEF__(strtod)(const char *__restrict__ nptr, char **__restrict__ endptr);
+extern long double __POSIX_DEF__(strtold)(const char *__restrict__ nptr, char **__restrict__ endptr);
 
 /* Integer Conversion */
-extern int atoi(const char *nptr);
-extern long int atol(const char *nptr);
-extern long long int atoll(const char *nptr);
-extern long int strtol(const char *__restrict__ nptr,
+extern int __POSIX_DEF__(atoi)(const char *nptr);
+extern long int __POSIX_DEF__(atol)(const char *nptr);
+extern long long int __POSIX_DEF__(atoll)(const char *nptr);
+extern long int __POSIX_DEF__(strtol)(const char *__restrict__ nptr,
     char **__restrict__ endptr, int base);
-extern long long int strtoll(const char *__restrict__ nptr,
+extern long long int __POSIX_DEF__(strtoll)(const char *__restrict__ nptr,
     char **__restrict__ endptr, int base);
-extern unsigned long int strtoul(const char *__restrict__ nptr,
+extern unsigned long int __POSIX_DEF__(strtoul)(const char *__restrict__ nptr,
     char **__restrict__ endptr, int base);
-extern unsigned long long int strtoull(
+extern unsigned long long int __POSIX_DEF__(strtoull)(
     const char *__restrict__ nptr, char **__restrict__ endptr, int base);
 
 /* Memory Allocation */
-extern void *malloc(size_t size)
+extern void *__POSIX_DEF__(malloc)(size_t size)
     __attribute__((malloc));
-extern void *calloc(size_t nelem, size_t elsize)
+extern void *__POSIX_DEF__(calloc)(size_t nelem, size_t elsize)
     __attribute__((malloc));
-extern void *realloc(void *ptr, size_t size)
+extern void *__POSIX_DEF__(realloc)(void *ptr, size_t size)
     __attribute__((warn_unused_result));
-extern void free(void *ptr);
+extern void __POSIX_DEF__(free)(void *ptr);
 
 /* Temporary Files */
-extern int mkstemp(char *tmpl);
+extern int __POSIX_DEF__(mkstemp)(char *tmpl);
 
 /* Pseudo-random number generator */
-extern int rand(void);
-extern void srand(unsigned int seed);
+extern int __POSIX_DEF__(rand)(void);
+extern void __POSIX_DEF__(srand)(unsigned int seed);
 
 /* Legacy Declarations */
-extern char *mktemp(char *tmpl);
+extern char *__POSIX_DEF__(mktemp)(char *tmpl);
 extern int bsd_getloadavg(double loadavg[], int nelem);
 
Index: uspace/lib/posix/include/posix/string.h
===================================================================
--- uspace/lib/posix/include/posix/string.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/string.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,4 +37,8 @@
 #define POSIX_STRING_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "sys/types.h"
 
@@ -70,54 +74,54 @@
 
 /* Copying and Concatenation */
-extern char *strcpy(char *__restrict__ dest, const char *__restrict__ src);
-extern char *strncpy(char *__restrict__ dest, const char *__restrict__ src, size_t n);
-extern char *stpcpy(char *__restrict__ dest, const char *__restrict__ src);
-extern char *stpncpy(char *__restrict__ dest, const char *__restrict__ src, size_t n);
-extern char *strcat(char *__restrict__ dest, const char *__restrict__ src);
-extern char *strncat(char *__restrict__ dest, const char *__restrict__ src, size_t n);
-extern void *memccpy(void *__restrict__ dest, const void *__restrict__ src, int c, size_t n);
-extern char *strdup(const char *s);
-extern char *strndup(const char *s, size_t n);
+extern char *__POSIX_DEF__(strcpy)(char *__restrict__ dest, const char *__restrict__ src);
+extern char *__POSIX_DEF__(strncpy)(char *__restrict__ dest, const char *__restrict__ src, size_t n);
+extern char *__POSIX_DEF__(stpcpy)(char *__restrict__ dest, const char *__restrict__ src);
+extern char *__POSIX_DEF__(stpncpy)(char *__restrict__ dest, const char *__restrict__ src, size_t n);
+extern char *__POSIX_DEF__(strcat)(char *__restrict__ dest, const char *__restrict__ src);
+extern char *__POSIX_DEF__(strncat)(char *__restrict__ dest, const char *__restrict__ src, size_t n);
+extern void *__POSIX_DEF__(memccpy)(void *__restrict__ dest, const void *__restrict__ src, int c, size_t n);
+extern char *__POSIX_DEF__(strdup)(const char *s);
+extern char *__POSIX_DEF__(strndup)(const char *s, size_t n);
 
 /* String/Array Comparison */
-extern int memcmp(const void *mem1, const void *mem2, size_t n);
-extern int strcmp(const char *s1, const char *s2);
-extern int strncmp(const char *s1, const char *s2, size_t n);
+extern int __POSIX_DEF__(memcmp)(const void *mem1, const void *mem2, size_t n);
+extern int __POSIX_DEF__(strcmp)(const char *s1, const char *s2);
+extern int __POSIX_DEF__(strncmp)(const char *s1, const char *s2, size_t n);
 
 /* Search Functions */
-extern void *memchr(const void *mem, int c, size_t n);
-extern char *strchr(const char *s, int c);
-extern char *strrchr(const char *s, int c);
+extern void *__POSIX_DEF__(memchr)(const void *mem, int c, size_t n);
+extern char *__POSIX_DEF__(strchr)(const char *s, int c);
+extern char *__POSIX_DEF__(strrchr)(const char *s, int c);
 extern char *gnu_strchrnul(const char *s, int c);
-extern char *strpbrk(const char *s1, const char *s2);
-extern size_t strcspn(const char *s1, const char *s2);
-extern size_t strspn(const char *s1, const char *s2);
-extern char *strstr(const char *haystack, const char *needle);
+extern char *__POSIX_DEF__(strpbrk)(const char *s1, const char *s2);
+extern size_t __POSIX_DEF__(strcspn)(const char *s1, const char *s2);
+extern size_t __POSIX_DEF__(strspn)(const char *s1, const char *s2);
+extern char *__POSIX_DEF__(strstr)(const char *haystack, const char *needle);
 
 /* Tokenization functions. */
-extern char *strtok_r(char *, const char *, char **);
-extern char *strtok(char *, const char *);
+extern char *__POSIX_DEF__(strtok_r)(char *, const char *, char **);
+extern char *__POSIX_DEF__(strtok)(char *, const char *);
 
 
 /* Collation Functions */
-extern int strcoll(const char *s1, const char *s2);
-extern size_t strxfrm(char *__restrict__ s1, const char *__restrict__ s2, size_t n);
+extern int __POSIX_DEF__(strcoll)(const char *s1, const char *s2);
+extern size_t __POSIX_DEF__(strxfrm)(char *__restrict__ s1, const char *__restrict__ s2, size_t n);
 
 /* Error Messages */
-extern char *strerror(int errnum);
-extern int strerror_r(int errnum, char *buf, size_t bufsz);
+extern char *__POSIX_DEF__(strerror)(int errnum);
+extern int __POSIX_DEF__(strerror_r)(int errnum, char *buf, size_t bufsz);
 
 /* String Length */
-extern size_t strlen(const char *s);
-extern size_t strnlen(const char *s, size_t n);
+extern size_t __POSIX_DEF__(strlen)(const char *s);
+extern size_t __POSIX_DEF__(strnlen)(const char *s, size_t n);
 
 /* Signal Messages */
-extern char *strsignal(int signum);
+extern char *__POSIX_DEF__(strsignal)(int signum);
 
 /* Legacy Declarations */
 #ifndef POSIX_STRINGS_H_
-extern int ffs(int i);
-extern int strcasecmp(const char *s1, const char *s2);
-extern int strncasecmp(const char *s1, const char *s2, size_t n);
+extern int __POSIX_DEF__(ffs)(int i);
+extern int __POSIX_DEF__(strcasecmp)(const char *s1, const char *s2);
+extern int __POSIX_DEF__(strncasecmp)(const char *s1, const char *s2, size_t n);
 #endif
 
Index: uspace/lib/posix/include/posix/strings.h
===================================================================
--- uspace/lib/posix/include/posix/strings.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/strings.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,15 +37,20 @@
 #define POSIX_STRINGS_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
+
 #include "libc/types/common.h"
 
 /* Search Functions */
 #ifndef POSIX_STRING_H_
-extern int ffs(int i);
+extern int __POSIX_DEF__(ffs)(int i);
 #endif
 
 /* String/Array Comparison */
 #ifndef POSIX_STRING_H_
-extern int strcasecmp(const char *s1, const char *s2);
-extern int strncasecmp(const char *s1, const char *s2, size_t n);
+extern int __POSIX_DEF__(strcasecmp)(const char *s1, const char *s2);
+extern int __POSIX_DEF__(strncasecmp)(const char *s1, const char *s2, size_t n);
 #endif
 
@@ -57,9 +62,9 @@
 
 /* Legacy Functions */
-extern int bcmp(const void *mem1, const void *mem2, size_t n);
-extern void bcopy(const void *src, void *dest, size_t n);
-extern void bzero(void *mem, size_t n);
-extern char *index(const char *s, int c);
-extern char *rindex(const char *s, int c);
+extern int __POSIX_DEF__(bcmp)(const void *mem1, const void *mem2, size_t n);
+extern void __POSIX_DEF__(bcopy)(const void *src, void *dest, size_t n);
+extern void __POSIX_DEF__(bzero)(void *mem, size_t n);
+extern char *__POSIX_DEF__(index)(const char *s, int c);
+extern char *__POSIX_DEF__(rindex)(const char *s, int c);
 
 
Index: uspace/lib/posix/include/posix/sys/mman.h
===================================================================
--- uspace/lib/posix/include/posix/sys/mman.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/sys/mman.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,4 +36,8 @@
 #define POSIX_SYS_MMAN_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "types.h"
 #include <abi/mm/as.h>
@@ -56,7 +60,8 @@
 #define PROT_EXEC  AS_AREA_EXEC
 
-extern void *mmap(void *start, size_t length, int prot, int flags, int fd,
-    off_t offset);
-extern int munmap(void *start, size_t length);
+extern void *
+__POSIX_DEF__(mmap)(void *start, size_t length, int prot, int flags, int fd,
+    __POSIX_DEF__(off_t) offset);
+extern int __POSIX_DEF__(munmap)(void *start, size_t length);
 
 
Index: uspace/lib/posix/include/posix/sys/stat.h
===================================================================
--- uspace/lib/posix/include/posix/sys/stat.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/sys/stat.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,4 +39,8 @@
 #include "types.h"
 #include "../time.h"
+
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
 
 /* values are the same as on Linux */
@@ -108,15 +112,15 @@
 #define S_ISSOCK(m) ((m & S_IFSOCK) != 0) /* socket? (Not in POSIX.1-1996.) */
 
-struct stat {
-	dev_t     st_dev;     /* ID of device containing file */
-	ino_t     st_ino;     /* inode number */
-	mode_t    st_mode;    /* protection */
-	nlink_t   st_nlink;   /* number of hard links */
-	uid_t     st_uid;     /* user ID of owner */
-	gid_t     st_gid;     /* group ID of owner */
-	dev_t     st_rdev;    /* device ID (if special file) */
-	off_t     st_size;    /* total size, in bytes */
-	blksize_t st_blksize; /* blocksize for file system I/O */
-	blkcnt_t  st_blocks;  /* number of 512B blocks allocated */
+struct __POSIX_DEF__(stat) {
+	__POSIX_DEF__(dev_t)     st_dev;     /* ID of device containing file */
+	__POSIX_DEF__(ino_t)     st_ino;     /* inode number */
+	__POSIX_DEF__(mode_t)    st_mode;    /* protection */
+	__POSIX_DEF__(nlink_t)   st_nlink;   /* number of hard links */
+	__POSIX_DEF__(uid_t)     st_uid;     /* user ID of owner */
+	__POSIX_DEF__(gid_t)     st_gid;     /* group ID of owner */
+	__POSIX_DEF__(dev_t)     st_rdev;    /* device ID (if special file) */
+	__POSIX_DEF__(off_t)     st_size;    /* total size, in bytes */
+	__POSIX_DEF__(blksize_t) st_blksize; /* blocksize for file system I/O */
+	__POSIX_DEF__(blkcnt_t)  st_blocks;  /* number of 512B blocks allocated */
 	time_t          st_atime;   /* time of last access */
 	time_t          st_mtime;   /* time of last modification */
@@ -124,10 +128,10 @@
 };
 
-extern int fstat(int fd, struct stat *st);
-extern int lstat(const char *__restrict__ path, struct stat *__restrict__ st);
-extern int stat(const char *__restrict__ path, struct stat *__restrict__ st);
-extern int chmod(const char *path, mode_t mode);
-extern mode_t umask(mode_t mask);
-extern int mkdir(const char *path, mode_t mode);
+extern int __POSIX_DEF__(fstat)(int fd, struct __POSIX_DEF__(stat) *st);
+extern int __POSIX_DEF__(lstat)(const char *__restrict__ path, struct __POSIX_DEF__(stat) *__restrict__ st);
+extern int __POSIX_DEF__(stat)(const char *__restrict__ path, struct __POSIX_DEF__(stat) *__restrict__ st);
+extern int __POSIX_DEF__(chmod)(const char *path, __POSIX_DEF__(mode_t) mode);
+extern __POSIX_DEF__(mode_t) __POSIX_DEF__(umask)(__POSIX_DEF__(mode_t) mask);
+extern int __POSIX_DEF__(mkdir)(const char *path, __POSIX_DEF__(mode_t) mode);
 
 
Index: uspace/lib/posix/include/posix/sys/time.h
===================================================================
--- uspace/lib/posix/include/posix/sys/time.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/sys/time.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -34,4 +34,8 @@
 #define POSIX_SYS_TIME_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "libc/sys/time.h"
 
Index: uspace/lib/posix/include/posix/sys/types.h
===================================================================
--- uspace/lib/posix/include/posix/sys/types.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/sys/types.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,25 +37,29 @@
 #define POSIX_SYS_TYPES_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "libc/offset.h"
 #include "libc/sys/time.h"
 #include "libc/types/common.h"
 
-typedef unsigned int ino_t;
-typedef unsigned int nlink_t;
-typedef unsigned int uid_t;
-typedef unsigned int gid_t;
-typedef off64_t off_t;
-typedef long blksize_t;
-typedef long blkcnt_t;
-typedef int64_t pid_t;
-typedef sysarg_t dev_t;
-typedef unsigned int mode_t;
+typedef unsigned int __POSIX_DEF__(ino_t);
+typedef unsigned int __POSIX_DEF__(nlink_t);
+typedef unsigned int __POSIX_DEF__(uid_t);
+typedef unsigned int __POSIX_DEF__(gid_t);
+typedef off64_t __POSIX_DEF__(off_t);
+typedef long __POSIX_DEF__(blksize_t);
+typedef long __POSIX_DEF__(blkcnt_t);
+typedef int64_t __POSIX_DEF__(pid_t);
+typedef sysarg_t __POSIX_DEF__(dev_t);
+typedef unsigned int __POSIX_DEF__(mode_t);
 
 /* PThread Types */
-typedef struct thread_attr thread_attr_t;
+typedef struct __POSIX_DEF__(thread_attr) __POSIX_DEF__(thread_attr_t);
 
 /* Clock Types */
-typedef long clock_t;
-typedef int clockid_t;
+typedef long __POSIX_DEF__(clock_t);
+typedef int __POSIX_DEF__(clockid_t);
 
 
Index: uspace/lib/posix/include/posix/sys/wait.h
===================================================================
--- uspace/lib/posix/include/posix/sys/wait.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/sys/wait.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,4 +36,8 @@
 #define POSIX_SYS_WAIT_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "types.h"
 
@@ -52,6 +56,6 @@
 extern int __posix_wtermsig(int status);
 
-extern pid_t wait(int *stat_ptr);
-extern pid_t waitpid(pid_t pid, int *stat_ptr, int options);
+extern __POSIX_DEF__(pid_t) __POSIX_DEF__(wait)(int *stat_ptr);
+extern __POSIX_DEF__(pid_t) __POSIX_DEF__(waitpid)(__POSIX_DEF__(pid_t) pid, int *stat_ptr, int options);
 
 
